/**
 * Title:	    Traces
 * Copyright:	    Copyright (c) Jan-Pascal van Best
 * Email:		janpascal@vanbest.org
 * Author:	    Jan-Pascal van Best
 **************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, version 2.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

package nl.tudelft.tbm.traces;


import java.util.*;
import java.util.logging.*;
import java.lang.*;
import nl.tudelft.tbm.graph.*;


/**
 * A simple implementation of the {@link Node} interface. This class implements
 * the {@link #isDeletable}/{@link #setDeletable} stuff. It also implements a
 * property dates. <b>DOCUMENTATION NOT FINISHED</b>
 *
 * @author	    Jan-Pascal van Best
 * @version	1.0
 */

public abstract class AbstractDatedNode extends AbstractNode {
    private static Logger logger = Logger.getLogger("nl.tudelft.tbm.traces");

    private Set dates = new HashSet();
    public AbstractDatedNode() {
        super();
    }

    public AbstractDatedNode(String name) {
        super(name);
    }

    public AbstractDatedNode(String name, String label) {
        super(name, label);
    }

    public void addDate(Date date) {
        dates.add(date);
    }

    public void addDates(Set dates) {
        this.dates.addAll(dates);
    }

    public Set getDates() {
        return dates;
    }

	public void clearDates() {
		dates = new HashSet();
	}

    private String datesString() {
        StringBuffer result = new StringBuffer();
        boolean first = true;

        for (Iterator i = dates.iterator(); i.hasNext();) {
            Date date = (Date) i.next();
            if (date!=null) {
                result.append(first ? "" + date.getTime() / 1000 : " " + date.getTime() / 1000);
                first = false;
            } else {
                logger.severe("AbstractDatedNode "+name+" has a null date!");
            }
        }
        return result.toString();
    }

    public List getPropertyNames() {
        String[] strings = {"dates"};
        List result = super.getPropertyNames();

        result.addAll(Arrays.asList(strings));
        return result;
    }

    public String getProperty(String name) {
        String result;

        if (name.equals("dates")) {
            result = datesString();
        } else
            result = super.getProperty(name);
        return result;
    }
}
    
