// This progarm is intended to query and display  from remote MySql database server
// that holds the TTM database file.

package nl.tudelft.tbm.traces;


import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.URL.*;
import java.sql.*;
import java.text.*;
import java.util.*;
import java.util.prefs.*;
import javax.swing.*;


public class MainApplet extends JApplet implements ActionListener {
    final static String PREFS_OUTPUT_PATH = "output_path";

    JMenuBar menuBar;

    ButtonGroup bgQueryType;
    JRadioButton rbQFull;
    JRadioButton rbQPartial;
    JRadioButton rbQSingle;

    private JButton bDoIt;
    private JButton bTest;
    private JFrame main;

    static String[] intervalStrings = {"minutes", "hours", "days", "weeks", "months", "years"};

    private JApplet self = this;

    public void init() {

        //	  JFrame main = new MainApp();

        JMenu menu, submenu;
        JMenuItem menuItem;

        menuBar = new JMenuBar();
        setJMenuBar(menuBar);

        //	  setTitle("Traces v"+Version.VERSION);

        menu = new JMenu("File");
        menu.setMnemonic(KeyEvent.VK_F);
        menu.getAccessibleContext().setAccessibleDescription(
            "The only menu in this program that has menu items");
        menuBar.add(menu);

        menuItem = new JMenuItem("Open");
        menuItem.addActionListener(this);
        menu.add(menuItem);
        menuItem = new JMenuItem("Options");
        menuItem.addActionListener(this);
        menu.add(menuItem);
        menuItem = new JMenuItem("Exit");
        menuItem.addActionListener(this);
        menu.add(menuItem);

        Container c = getContentPane();

        c.setLayout(new GridBagLayout());

        // Create a constraints object, and specify some default values
        GridBagConstraints g = new GridBagConstraints();

        g.fill = GridBagConstraints.BOTH;   // components grow in both dimensions
        g.insets = new Insets(5, 5, 5, 5); // 5-pixel margins on all sides

        bgQueryType = new ButtonGroup();
        rbQFull = new JRadioButton("All test boxes", false);
        rbQPartial = new JRadioButton("Subset of boxes", false);
        rbQSingle = new JRadioButton("Single trace", true);
        bgQueryType.add(rbQFull);
        bgQueryType.add(rbQPartial);
        bgQueryType.add(rbQSingle);

        bDoIt = new JButton("Do it");
        bDoIt.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    if (e.getSource() == bDoIt) doIt();
                }
            }
        );

        bTest = new JButton("Test");
        bTest.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    if (e.getSource() == bTest) test();
                }
            }
        );

        int line = -1;

        JLabel lQType = new JLabel("Query type: ");

        g.gridx = 0;
        g.gridy = ++line;
        g.gridwidth = 1;
        g.gridheight = 1;
        g.weightx = 1.0;
        g.weighty = 0.0;
        c.add(lQType, g);

        g.gridx = 1;
        g.gridy = line;
        g.gridwidth = 1;
        g.gridheight = 1;
        g.weightx = 1.0;
        g.weighty = 0.0;
        c.add(rbQFull, g);

        g.gridx = 1;
        g.gridy = ++line;
        g.gridwidth = 1;
        g.gridheight = 1;
        g.weightx = 1.0;
        g.weighty = 0.0;
        c.add(rbQPartial, g);

        g.gridx = 1;
        g.gridy = ++line;
        g.gridwidth = 1;
        g.gridheight = 1;
        g.weightx = 1.0;
        g.weighty = 0.0;
        c.add(rbQSingle, g);

        g.gridx = 0;
        g.gridy = ++line;
        g.gridwidth = 1;
        g.gridheight = 1;
        g.weightx = 1.0;
        g.weighty = 0.0;
        c.add(bDoIt, g);

        g.gridx = 1;
        g.gridy = line;
        g.gridwidth = 1;
        g.gridheight = 1;
        g.weightx = 1.0;
        g.weighty = 0.0;
        c.add(bTest, g);

        //	  pack();
        show();
    }

    public void actionPerformed(ActionEvent e) {
        //...Get information from the action event...
        String command = e.getActionCommand();

        // Process command
        if (command.equals("Open")) {
            System.out.println("Open doesn't do anything");
        } else if (command.equals("Options")) {
            //	      options.setLocationRelativeTo(this);
            //	      options.setVisible(true);
            System.out.println("Done options");
        } else if (command.equals("Exit")) {
            System.out.println("Exit");
            System.exit(0);
        }
    }

    void doIt() {
        Vector traces = new Vector();

        TestBox.clearCache();

    }

    void test() {
        MainApp main;

        MainApp.isApplet = true;
        main = new MainApp();

    }

}

