/**
 * Title:	    Traces
 * Copyright:	Copyright (c) Jan-Pascal van Best
 * Email:	    janpascal@vanbest.org
 * Author:	    Jan-Pascal van Best
 * Web: 	    http://www.tbm.tudelft.nl/webstaf/janb/software/traces/api/index.html
 **************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, version 2.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

package nl.tudelft.tbm.traces;


// Standard Java packages
import java.util.*;
import java.util.logging.*;
import java.lang.*;

// Own packagages
import nl.tudelft.tbm.matrix.*;

class NNLS2 {
    /** 
     * Solves the matrix equation Ax=b in the least-squares sense,
     * taking into account the constraint x>=0. Algorithm from
     * Charles L. Lawson, Richars J. Hanson, Solving Least Squares Problems, 
     * SIAM, Philadelphia, 1995
     * A is an mxn matrix of doubles; b is an array of m doubles
     */

    public Matrix NNLS(Matrix AA, Matrix BB) {
        SimpleMatrix A;
        SimpleMatrix B;
        if (AA typeof SimpleMatrix) {
            A = (SimpleMatrix) AA;
        } else {
            A = new SimpleMatrix(AA);
        }

        if (BB typeof SimpleMatrix) {
            B = (SimpleMatrix) BB;
        } else {
            B = new SimpleMatrix(BB);
        }

        SimpleMatrix AT = (SimpleMatrix) A.transpose();

        int m = A.getRows();
        int n = A.getColumns();

        boolean[] P = new boolean[n];
        boolean[] Z = new boolean[n];
        for(int i=0; i<n; i++) {
            P[i] = false;
            Z[i] = true;
        }
        int Zsize = n;

        SimpleMatrix x = new SimpleMatrix(n,1);

        // Step 2
        SimpleMatrix w = AT.times(B.minus(A.times(x)));


    }
}
