/**
 * Title:	Traces
 * Copyright:	Copyright (c) Jan-Pascal van Best
 * Email:	    janpascal@vanbest.org
 * @author	    Jan-Pascal van Best
 **************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, version 2.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

package nl.tudelft.tbm.traces;


import java.util.*;
import java.io.*;
import java.lang.*;
import org.xml.sax.*;
import nl.tudelft.tbm.graph.*;


public class Segment extends DelayPair {
    List links;

    public Segment() {
        super(null, null);
        links = new ArrayList();
    }

    public void addLink(DelayPair link) {
        links.add(link);
        addDates(link.getDates());
        if (x == null) x = link.x;
        y = link.y;
    }

    public String getName() {
        return "";
    }

    public String getLabel() {
        return x.toString() + "->...->" + y.toString();
    }

    public List getPropertyNames() {
        String[] strings = {"links"};
        List result = super.getPropertyNames();

        result.addAll(Arrays.asList(strings));
        return result;
    }

    String linksString() {
        if (x == null) return "";
        StringBuffer s = new StringBuffer();

        s.append(x.toString());
        for (Iterator i = links.iterator(); i.hasNext();) {
            Object o = ((DelayPair) i.next()).y;

            if (o instanceof Attributed) {
                s.append(" " + ((Attributed) o).getName());
            } else {
                s.append(" " + o.toString());
            }
        }
        return s.toString();
    }

    public String getProperty(String name) {
        String result;

        if (name.equals("links")) {
            result = linksString();
        } else
            result = super.getProperty(name);
        return result;
    }

    public boolean equals(Object obj) {
        boolean result = false;

        if (obj instanceof Segment) {
            Segment s = (Segment) obj;

            result = (links.equals(s.links));
        } else {
            result = false;
        }
        return result;
    }

    public int hashCode() {
        return links.hashCode();
    }

}

