/**
 * Title:	    Traces
 * Copyright:	Copyright (c) Jan-Pascal van Best
 * Email:	    janpascal@vanbest.org
 * Author:	    Jan-Pascal van Best
 * Web: 	    http://www.tbm.tudelft.nl/webstaf/janb/software/traces/api/index.html
 **************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, version 2.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

package nl.tudelft.tbm.traces;

// Standard Java packages
import java.util.*;
import java.util.logging.*;
import java.io.*;
import java.lang.*;
import java.net.*;

public class SwingHandler extends Handler {
    public SwingHandler() {
        super();
    }
        
    public void close() {
        Log.log.hide();
    }

    public void flush() {
        // do nothing, since we don't buffer
    }

    public void publish(LogRecord record) {
        Log.logChar(getFormatter().format(record));
        Log.log.truncate();
        Log.log.scrollToEnd();
    }
}
